CREATE OR REPLACE PROCEDURE TRANSFERE_SALDO_CONTCTBL(
  P_CDEMPRESA    IN  EMPRESA.CDEMPRESA%TYPE,
  P_CDCONTADEST  IN  CONTCTBL.CDCONTCTBL%TYPE,
  P_CDHISTPADR   IN  HISTPADR.CDHISTPADR%TYPE,
  P_DTSALDO      IN  SALDEMPR.DTSALDEMPR%TYPE,
  P_CDLOTE       IN  VARCHAR2,
  P_NRLISTA      IN  LISTA.NRLISTA%TYPE,
  P_IDENCERRAMEN IN  VARCHAR2)
AS
  V_CDLOTE       VARCHAR2(20);
  V_SEQUENCIAL   VARCHAR2(20);
  V_NRLANCLOTE   VARCHAR2(06);
  V_EXISTELOTE   VARCHAR2(20);
  V_DTINICIAL    DATE;
  V_DTFINAL      DATE;
  V_IDCONTCCUS   VARCHAR2(01);
  V_DSHISTPADR   VARCHAR2(150);
  V_FILRAT       VARCHAR2(10);
  V_CENTCUSTRAT  VARCHAR2(10);
  v_SOMASALDO    FLOAT;
  V_OBSERVACAO VARCHAR2(50);
BEGIN
  V_CDLOTE := P_CDLOTE;
  NOVO_CODIGO(V_CDLOTE, V_SEQUENCIAL, 1);

  V_CDLOTE := REPLACE(V_CDLOTE, '[EMP]', P_CDEMPRESA);
  V_CDLOTE := REPLACE(V_CDLOTE, '[ANO]', TO_CHAR(P_DTSALDO, 'YYYY'));
  V_CDLOTE := REPLACE(V_CDLOTE, '[MES]', TO_CHAR(P_DTSALDO, 'MM'));
  V_CDLOTE := REPLACE(V_CDLOTE, '[DIA]', TO_CHAR(P_DTSALDO, 'DD'));
  V_CDLOTE := REPLACE(V_CDLOTE, '[SEQ]', SUBSTR(V_SEQUENCIAL,17,4));

  BEGIN
    SELECT MAX(NRLANCLOTE)
      INTO V_NRLANCLOTE
      FROM LANCLOTE
     WHERE CDEMPRESA = P_CDEMPRESA
       AND CDLOTE = V_CDLOTE;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN
      V_NRLANCLOTE := NULL;
  END;

  IF V_NRLANCLOTE IS NULL THEN
      V_NRLANCLOTE := '000001';
  ELSE
     V_NRLANCLOTE := LPAD(TO_CHAR(TO_NUMBER(V_NRLANCLOTE) + 1),6,'0');
  END IF;

  BEGIN
    SELECT CDLOTE
      INTO V_EXISTELOTE
      FROM CAPALOTE
     WHERE CDEMPRESA = P_CDEMPRESA
       AND CDLOTE = V_CDLOTE;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN
      V_EXISTELOTE := NULL;
  END;

   V_DTINICIAL := P_DTSALDO;
   V_DTFINAL := P_DTSALDO;

  IF P_IDENCERRAMEN = 'F' THEN
     V_OBSERVACAO := 'Encerramento Fiscal';
  ELSIF P_IDENCERRAMEN = 'S' THEN
     V_OBSERVACAO := 'Encerramento Societrio';
  ELSE
      V_OBSERVACAO := NULL;
  END IF;

  IF V_EXISTELOTE IS NULL THEN
    INSERT INTO CAPALOTE
      (CDEMPRESA, CDLOTE, DTINICLOTE, DTFINALOTE, IDTPMOVLOTE,IDLOTE, DSOBSELOTE)
    VALUES
      (P_CDEMPRESA, V_CDLOTE, V_DTINICIAL, V_DTFINAL, '', 'D', V_OBSERVACAO);
  END IF;

  BEGIN
     SELECT DSHISTPADR
       INTO V_DSHISTPADR
       FROM HISTPADR
      WHERE CDHISTPADR = P_CDHISTPADR;
  EXCEPTION
     WHEN NO_DATA_FOUND THEN
        V_DSHISTPADR := NULL;
  END;

  V_SOMASALDO := 0;
  /*
    O Parmeto P_NRLISTA ser nulo quando a procedure for chamada pelo
    Zeedhi, pois no sistema criado pelo framework ser considerado o campo
    IDGRUPOCONTA, da tabela CONTCTBL, para buscar todas as contas de resultado.
    As contas so definidas como sendo de resultado quando tiverem este campo igual a R
  */
  FOR C_SALDEMPR IN
     ( /* Select do Delphi */
      SELECT CDEMPRESA, CDCONTCTBL, DTSALDEMPR, VRSALDEMPR
        FROM SALDEMPR
       WHERE (CDEMPRESA  = P_CDEMPRESA)
         AND (CDCONTCTBL IN (SELECT CDLISTA
                               FROM LISTA
                              WHERE NRLISTA = P_NRLISTA))
         AND (DTSALDEMPR = P_DTSALDO)
         AND P_IDENCERRAMEN = 'F'
         AND P_NRLISTA IS NOT NULL
       UNION
      SELECT CDEMPRESA, CDCONTCTBL, DTSALDOSOCIET DTSALDEMPR, VRSALDOSOCIET VRSALDEMPR
        FROM SALDOSOCIET
       WHERE (CDEMPRESA  = P_CDEMPRESA)
         AND (CDCONTCTBL IN (SELECT CDLISTA
                               FROM LISTA
                              WHERE NRLISTA = P_NRLISTA))
         AND (DTSALDOSOCIET = P_DTSALDO)
         AND P_IDENCERRAMEN = 'S'
         AND P_NRLISTA IS NOT NULL

       UNION
      /* Select do Zeedhi */
      SELECT S.CDEMPRESA, S.CDCONTCTBL, S.DTSALDEMPR, S.VRSALDEMPR
        FROM SALDEMPR S, CONTCTBL C
       WHERE S.CDEMPRESA  = P_CDEMPRESA
         AND S.DTSALDEMPR = P_DTSALDO
         AND P_IDENCERRAMEN = 'F'
         AND P_NRLISTA IS NULL
         AND S.CDCONTCTBL = C.CDCONTCTBL
         AND C.IDTIPOCONT = 'A'
         AND C.IDGRUPOCONTA = 'R'
         AND C.IDCONTCCUS <> 'R'
         AND P_NRLISTA IS NULL
       UNION
      SELECT S.CDEMPRESA, S.CDCONTCTBL, S.DTSALDOSOCIET DTSALDEMPR, S.VRSALDOSOCIET VRSALDEMPR
        FROM SALDOSOCIET S, CONTCTBL C
       WHERE S.CDEMPRESA  = P_CDEMPRESA
         AND S.DTSALDOSOCIET = P_DTSALDO
         AND P_IDENCERRAMEN = 'F'
         AND P_NRLISTA IS NULL
         AND S.CDCONTCTBL = C.CDCONTCTBL
         AND C.IDTIPOCONT = 'A'
         AND C.IDGRUPOCONTA = 'R'
         AND C.IDCONTCCUS <> 'R'
         AND S.DTSALDOSOCIET = P_DTSALDO
         AND P_IDENCERRAMEN = 'S'
         AND P_NRLISTA IS NULL) LOOP

         NOVA_PARTIDA(P_CDEMPRESA, V_CDLOTE, P_DTSALDO, V_NRLANCLOTE, C_SALDEMPR.CDCONTCTBL, P_CDHISTPADR, V_DSHISTPADR, ROUND(C_SALDEMPR.VRSALDEMPR * -1, 2),'','','', '99999999999999999999', 'N');

         BEGIN
            SELECT IDCONTCCUS
              INTO V_IDCONTCCUS
              FROM CONTCTBL
             WHERE CDCONTCTBL = C_SALDEMPR.CDCONTCTBL;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_IDCONTCCUS := NULL;
         END;

         IF V_IDCONTCCUS <> 'O' THEN
            FOR C_RAT IN
               (SELECT CDFILIAL, CDCENTCUST, VRSALDCCUS
                  FROM SALDCCUS
                 WHERE (CDEMPRESA  = P_CDEMPRESA)   AND
                       (CDCONTCTBL = C_SALDEMPR.CDCONTCTBL) AND
                       (DTSALDCCUS = C_SALDEMPR.DTSALDEMPR) AND
                       (VRSALDCCUS <> 0) AND
                       (P_IDENCERRAMEN = 'F')
                 UNION

                SELECT CDFILIAL, CDCENTCUST, VRSALDCCUSSOC VRSALDCCUS
                  FROM SALDCCUSSOC
                 WHERE (CDEMPRESA  = P_CDEMPRESA)   AND
                       (CDCONTCTBL = C_SALDEMPR.CDCONTCTBL) AND
                       (DTSALDCCUSSOC = C_SALDEMPR.DTSALDEMPR) AND
                       (VRSALDCCUSSOC <> 0) AND
                       (P_IDENCERRAMEN = 'S')) LOOP
                      RATEIO_PARTIDA(P_CDEMPRESA, V_CDLOTE, P_DTSALDO, V_NRLANCLOTE, C_RAT.CDFILIAL,
                                     C_RAT.CDCENTCUST, ROUND(C_RAT.VRSALDCCUS * -1, 2));
             END LOOP;
          END IF;
          V_SOMASALDO := V_SOMASALDO + C_SALDEMPR.VRSALDEMPR;
  END LOOP;

  NOVA_PARTIDA(P_CDEMPRESA, V_CDLOTE, P_DTSALDO, V_NRLANCLOTE, P_CDCONTADEST, P_CDHISTPADR, V_DSHISTPADR, ROUND(V_SOMASALDO, 2),'','','', '99999999999999999999', 'N');

  UPDATE LANCLOTE
     SET IDTPLANCLOTE = P_IDENCERRAMEN
   WHERE CDEMPRESA = P_CDEMPRESA
     AND CDLOTE    = V_CDLOTE;

  DELETE
    FROM LISTA
   WHERE NRLISTA = P_NRLISTA;

END;
/

-- VERSAO --
BEGIN ATUVEROBJ('TRANSFERE_SALDO_CONTCTBL','5.45.xxx'); END;
/